
/* MtestAI Brain */
/* To do:	- include ai settings like aggressiveness, invasivity, activity */
/* 		- include probability, random/luck */
/* 		- AIChat einrichten */
/*		- more company and president names to choose from*/
/* 		- estimate cost for bus route */
/*		- build bus route*/
/*		- regular maintenance (profitable?, new vehicles?)*/
/*		- evaluate costs for each action*/
//		- BribeTown function
//		- support IsBuildable with FlattenArea

class MtestAI extends AIController {
	function Start();
}
//-----------------------------------------

/* Heart of MtestAI */

function MtestAI::Start()
{
	/* Say hello to the user */
	AILog.Info("Hallo, ich bin eine AI. Mein Name ist MtestAI.");
//	AIController.GetSetting(invasivity);
//	AILog.Info("invasivity: " + invasivity);

	RemoveSigns();
	CompanyController();
	BuildAirBridge();

//	Random(77);
//	TestFunction();

	/* We need our local ticker, as GetTick() will skip ticks */
	local ticker = 0;
	/* Determine time we may sleep */
	local sleepingtime = 10;
	/* Let's go on for ever */
	local i = 0;
	while (true) {
		/*AILog.Info(i + " - Tick - " + GetTick());*/

		/* Heartbeat */
		if((i%5)==0) {
			AILog.Info(i + " - Tick - " + GetTick());
		}

		if((i%30)==10) {
			AILog.Info(i + " - Payday - ");
			RepayLoan();
		}
		if((i%100)==50) {
			AILog.Info(i + " - Manage airports - ");
			ManageAirports();
		}
		if((i%100)==60) {
			AILog.Info(i + " - Manage airplanes - ");
			ManageAirplanes();
		}
	/*	if((i%100)==0) {
			AILog.Info(i + " - Bus - ");
		}*/

		EventManager();


		/* Make sure we do not create infinite loops */
		Sleep(sleepingtime);
		ticker += sleepingtime;
		i++;
	}
}
//---------------------------------------------------

/* Company controller */

function MtestAI::CompanyController() {
	AILog.Info("Set company details.");
	AICompany.SetPresidentName("Malte's AI");
	if (!AICompany.SetCompanyName("MtestAI")) {
		local i = 2;
		AICompany.SetPresidentName("Malte's AI #" + i);
		while (!AICompany.SetCompanyName("MtestAI #" + i)) {
			i++;
			AICompany.SetPresidentName("Malte's AI #" + i);
		}
	}

	BuildHQ();
}
//-------------------------------------------------------

/* Build headquarter in random town */

function MtestAI::BuildHQ() {
	AILog.Info("function BuildHQ");
	local townlist = AITownList();
	local rand = Random(townlist.Count());
	local townid = BiggestTown(rand);
	local hqpos = AITown.GetLocation(townid);
	local hqtown = AITown.GetName(townid);
	local buildable = false;
	local freeplace = 0;
	local hq = 0;
/*	local i = 0;
	while (buildable == false) {
		i++;
//		hqpos = hqpos + AIMap.GetTileIndex(10, 0);
		freeplace = FindFreePlace(hqpos, 2, 2, 12, i, 0);
		AILog.Info("  " + i + ". planned headquarter position: " + freeplace);
		buildable = IsBuildable(freeplace, 2, 2);
	}*/
//	hqpos = hqpos + AIMap.GetTileIndex(10, 0);
	freeplace = FindPlaceNearTile(hqpos, 2, 2, 4, 1, 0.5);
	EraseArea(freeplace, 2, 2, 0.5);
	buildable = IsBuildable(freeplace, 2, 2);
	hq = AICompany.BuildCompanyHQ(freeplace);
	if (hq == false) {
		AILog.Info("  Konnte HQ NICHT in " + hqtown + " bauen.");
	} else {
		AILog.Info("  Konnte HQ in " + hqtown + " bauen.");
	}
}
//-----------------------------------------------

/* Removes most signs from map */

function MtestAI::RemoveSigns() {
	for(local i=0; i < AISign.GetMaxSignID(); i++) {
      	if (AISign.IsValidSign(i)) {
			AISign.RemoveSign(i);
		}
	}
}
//-------------------------------------------------

/* Repays loan */
/*To do:	-...*/

function MtestAI::RepayLoan() {
	local loaninterval = AICompany.GetLoanInterval();
	local mymoney = AICompany.GetBankBalance(8);
	local myloan = AICompany.GetLoanAmount();
	local total = mymoney - myloan;
	AILog.Info("Status - Geld: " + mymoney + "; Kredit: " + myloan);
	if (mymoney >= loaninterval) {
		/* Pay back */
		AICompany.SetMinimumLoanAmount(total*-1);
	} else if (mymoney < 0) {
		/* Borrow loan */
		AICompany.SetMinimumLoanAmount(total*-1);	
	}
	mymoney = AICompany.GetBankBalance(8);
	myloan = AICompany.GetLoanAmount();
	AILog.Info("Neuer Status - Geld: " + mymoney + "; Kredit: " + myloan);
}
//-----------------------------------------------------------------

/* Borrow money, returns boolean */

function MtestAI::BorrowMoney(neededmoney) {
	AILog.Info("function BorrowMoney(" + neededmoney + ")");
	local newloan = 0;
	local loan = AICompany.GetLoanAmount();
	local konto = AICompany.GetBankBalance(AICompany.MY_COMPANY);
	if (konto < neededmoney) {
		newloan = loan - konto + neededmoney;
		
		if (AICompany.SetMinimumLoanAmount(newloan) == false) {
			AILog.Info(AICompany.GetMaxLoanAmount() + " Kann KEINEN neuen Kredit aufnehmen!" + newloan);
			return false;
		} else {
			return true;
		}
	}

}
//--------------------------------------------------

/* Event manager */
/*To do:	- handle all events*/

function MtestAI::EventManager() {
	AIEventController.EnableAllEvents();
	AIEventController.DisableEvent(AIEvent.AI_ET_SUBSIDY_OFFER_EXPIRED);
	AIEventController.DisableEvent(AIEvent.AI_ET_SUBSIDY_EXPIRED);
	AIEventController.DisableEvent(AIEvent.AI_ET_STATION_FIRST_VEHICLE);
	AIEventController.DisableEvent(AIEvent.AI_ET_ENGINE_AVAILABLE);

	while (AIEventController.IsEventWaiting()) {
		AILog.Info("An event happened...");
		local event = AIEventController.GetNextEvent();
		switch (event.GetEventType()) {
			case AIEvent.AI_ET_SUBSIDY_OFFER:
				AILog.Info("Subventionsangebot");
				break;
			case AIEvent.AI_ET_SUBSIDY_AWARDED:
				AILog.Info("Subvention bekommen.");
				break;
			case AIEvent.AI_ET_ENGINE_PREVIEW:
				local instance = AIEventEnginePreview.Convert(event);
				local vehicletype = instance.GetVehicleType();	/*1-Road; 3-Air*/
				local vehiclename = instance.GetName();
				AILog.Info("1 Jahr exklusiver " + vehicletype + "-Test fuer '" + vehiclename + "'" );
				if (instance.AcceptPreview() == true) {
					AILog.Info("Akzeptiert");
				} else {
					AILog.Info("NICHT akzeptiert");
				}
				break;
			case AIEvent.AI_ET_COMPANY_NEW:
				local instance = AIEventCompanyNew.Convert(event);
				local companyid = instance.GetCompanyID();
				local companyname = AICompany.GetCompanyName(companyid);
				AILog.Info("Welcome in the game '" + companyname + "'!");
				break;
			case AIEvent.AI_ET_COMPANY_IN_TROUBLE:
				local instance = AIEventCompanyInTrouble.Convert(event);
				local companyid = instance.GetCompanyID();
				local companyname = AICompany.GetCompanyName(companyid);
				AILog.Info("'" + companyname + "' ist in Notlage!");
				break;
			case AIEvent.AI_ET_COMPANY_MERGER:
				local instance = AIEventCompanyMerger.Convert(event);
				local oldcompanyid = instance.GetOldCompanyID();
				local oldcompanyname = AICompany.GetCompanyName(oldcompanyid);
				local newcompanyid = instance.GetNewCompanyID();
				local newcompanyname = AICompany.GetCompanyName(newcompanyid);
				AILog.Info("'" + oldcompanyname + "' wurde von '" + newcompanyname + "' gekauft!");
				break;
			case AIEvent.AI_ET_COMPANY_BANKRUPT:
				local instance = AIEventCompanyBankrupt.Convert(event);
				local companyid = instance.GetCompanyID();
				local companyname = AICompany.GetCompanyName(companyid);
				AILog.Info("'" + companyname + "' ist bankrott.");
				break;
			case AIEvent.AI_ET_VEHICLE_CRASHED:
				local instance = AIEventVehicleCrashed.Convert(event);
				local vehicleid = instance.GetVehicleID();
				AILog.Info("Fahrzeug verunglckt: " + vehicleid);
				break;
			case AIEvent.AI_ET_VEHICLE_LOST:
				AILog.Info("Fahrzeug verloren");
				break;
			case AIEvent.AI_ET_VEHICLE_WAITING_IN_DEPOT:
				AILog.Info("Fahrzeug wartet im Depot");
				local instance = AIEventVehicleWaitingInDepot.Convert(event);
				local vehicleid = instance.GetVehicleID();
				if (AIVehicle.GetAgeLeft(vehicleid) < 0) {
					AIVehicle.SellVehicle(vehicleid);
					AILog.Info("  Vehicle old and sold.");
				}
				break;
			case AIEvent.AI_ET_VEHICLE_UNPROFITABLE:
				AILog.Info("Fahrzeug macht Verluste");
				break;
			case AIEvent.AI_ET_INDUSTRY_OPEN:
				local instance = AIEventIndustryOpen.Convert(event);
				local industryid = instance.GetIndustryID();
				local industrytype = AIIndustry.GetName(industryid);
				AILog.Info("'" + industrytype + "' wird eroeffnet.");
				break;
			case AIEvent.AI_ET_INDUSTRY_CLOSE:
				local instance = AIEventIndustryClose.Convert(event);
				local industryid = instance.GetIndustryID();
				local industrytype = AIIndustry.GetName(industryid);
				AILog.Info("'" + industrytype + "' wurde geschlossen!");
				break;
		}
	}
}
//----------------------------------------------------

/* Find biggest town, returns town id */
/* To do:	- ... */

function MtestAI::BiggestTown(townnumber) {
	AILog.Info("function BiggestTown (" + townnumber + ")");
	local i = 0;
	local townid = 0;
	local townlist = AITownList();
	townlist.Valuate(AITown.GetPopulation);
	townlist.Sort(AIAbstractList.SORT_BY_VALUE, false);
	townid = townlist.Begin();
	for (i=1; i<townnumber; i++) {
		townid = townlist.Next();
	}
	local biggesttown = AITown.GetName(townid);
	local townpos = AITown.GetLocation(townid);
	AILog.Info("  The " + townnumber + ". biggest town is " + biggesttown + " (id: " + townid + ") on location: " + townpos);
	/*AISign.BuildSign(townpos, "Groesste Stadt");*/
	return townid;
}
//-------------------------------------------------------

/* Is Area Buildable? Returns boolean */

function MtestAI::IsBuildable(tile, width, length) {

	AILog.Info("function IsBuildable (" + tile + "; " + width + ", " + length + ")");
	local tilepos = 0;
	local heighttobuild = 0;
	local area = AIList();
	local ind = 0;
	local i = 0;
	for (i = 0; i < width; i++) {
		local k = 0;
		for (k = 0; k < length; k++) {
			tilepos = tile + AIMap.GetTileIndex(i, k);
			
			heighttobuild = TileHeightToBuild(tilepos);
//			AILog.Info("  " + i + ", " + k + " Bauhoehe: " + heighttobuild);
			area.AddItem(ind, heighttobuild);
			if (heighttobuild < 0) {
				return false;
			}
			ind++;
		}
	}
	area.KeepValue(heighttobuild);
	if (area.Count() == width * length) {
		AILog.Info("  Flaeche ist bebaubar.");
		/*AISign.BuildSign(tilepos, "Hier Flaeche bebaubar.");*/
		return true;
	} else {
		AILog.Info("  Flaeche NICHT bebaubar.");
		return false;
	}

}
//-----------

/* Auxfunction; returns heighttobuild */

function MtestAI::TileHeightToBuild(tile) {
	local tileslope = AITile.GetSlope(tile);
	local tileheight = AITile.GetHeight(tile);
	local heighttobuild = 0;
	local slopeheight = 0;
	/*AILog.Info("Slope: " + tileslope);*/
	switch (tileslope) {
		/* North corner is reason for tileheight!? */
		case AITile.SLOPE_FLAT:
			slopeheight = 0;
			break;
		case AITile.SLOPE_W:
			slopeheight = 1;
			break;
		case AITile.SLOPE_S:
			slopeheight = 1;
			break;
		case AITile.SLOPE_E:
			slopeheight = 1;
			break;
		case AITile.SLOPE_N:
			slopeheight = 0;
			break;
		case AITile.SLOPE_STEEP:
			slopeheight = -20;
			break;
		case AITile.SLOPE_NW:
			slopeheight = 0;
			break;
		case AITile.SLOPE_SW:
			slopeheight = 1;
			break;
		case AITile.SLOPE_SE:
			slopeheight = 1;
			break;
		case AITile.SLOPE_NE:
			slopeheight = 0;
			break;
		case AITile.SLOPE_EW:
			slopeheight = 1;
			break;
		case AITile.SLOPE_NS:
			slopeheight = 0;
			break;
		case AITile.SLOPE_ELEVATED:
			slopeheight = 1;
			break;
		case AITile.SLOPE_NWS:
			slopeheight = 0;
			break;
		case AITile.SLOPE_WSE:
			slopeheight = 1;
			break;
		case AITile.SLOPE_SEN:
			slopeheight = 0;
			break;
		case AITile.SLOPE_ENW:
			slopeheight = 0;
			break;
		case AITile.SLOPE_STEEP_W:
			slopeheight = -21;
			break;
		case AITile.SLOPE_STEEP_S:
			slopeheight = -22;
			break;
		case AITile.SLOPE_STEEP_E:
			slopeheight = -23;
			break;
		case AITile.SLOPE_STEEP_N:
			slopeheight = -24;
			break;
		case AITile.SLOPE_INVALID:
			slopeheight = -30;
			break;
	}
	if (slopeheight < -10) {
		AILog.Info("Error: " + slopeheight);
		return -1;
	} else {
		heighttobuild = tileheight + slopeheight;
		return heighttobuild;
	}
}
//-------------------------------------------------------

/* FlattenArea, returns boolean */
// todo:	- include boolean; done

function MtestAI::FlattenArea(tile, width, length, level) {
{//begin TM
local scout = AITransactionMode();
	AILog.Info("function FlattenArea(" + tile + "; " + width + ", " + length + ";" + level + ")");
	local done = true;
	local heightsum = 0;
	local i = 0;
	for (i=0; i < width; i++) {
		local j = 0;
		for (j=0; j < length; j++) {
			local tilepos = tile + AIMap.GetTileIndex(i, j);
			local tileheight = AITile.GetHeight(tilepos);
			heightsum = heightsum + tileheight;
//			AILog.Info("  " + i + ", " + j + "; Hoehe: " + tileheight + "; Gesamt: " + heightsum);
		}
	}
	local area = width * length;
	local averageheight = (heightsum / area);
	AILog.Info("Mittlere Hoehe: " + averageheight);
	averageheight = averageheight + level;
	if (averageheight == 0) {
		done = false;
	}
	local k = 0;
	for (k=0; k < width; k++) {
		local l = 0;
		for (l=0; l < length; l++) {
			local tilepos = tile + AIMap.GetTileIndex(k, l);
			local tileheight = AITile.GetHeight(tilepos);
			local heightdifference = (averageheight - tileheight);
//			AILog.Info("  " + k + ", " + l + "; Hoehe: " + tileheight + "; Differenz: " + heightdifference);
			if (heightdifference > 0) {
//				AILog.Info("  positive difference: " + heightdifference);
				if (k == 0 && l == 0) {
					local m = 0;
					for (m=0; m < heightdifference; m++) { 
						AITile.RaiseTile(tilepos, AITile.SLOPE_N);
						if (AIError.GetLastErrorString() != "ERR_NONE") {
							AILog.Info("Fehler: " + AIError.GetLastErrorString());
							done = false;
						}
					}
				} else {
					heightdifference = 1;
					AITile.RaiseTile(tilepos, AITile.SLOPE_N);
				}
			} else if (heightdifference < 0) {
//				AILog.Info("  negative difference: " + heightdifference);
				if (k == 0 && l == 0) {
					local m = 0;
					for (m=0; m > heightdifference; m--) { 
						AITile.LowerTile(tilepos, AITile.SLOPE_N);
						if (AIError.GetLastErrorString() != "ERR_NONE") {
							AILog.Info("Fehler: " + AIError.GetLastErrorString());
							done = false;
						}
					}
				} else {
					heightdifference = -1;
					AITile.LowerTile(tilepos, AITile.SLOPE_N);
				}
			}
			if (AIError.GetLastErrorString() != "ERR_NONE") {
				AILog.Info("Fehler: " + AIError.GetLastErrorString());
				done = false;
			}
			tileheight = AITile.GetHeight(tilepos);
		}
	}
	if (done == true) {
		scout.Execute();
		AILog.Info("Flaeche planiert.");
		return done;
	} else {
		scout.Stop();
		AILog.Info("Flaeche NICHT planiert.");
		AILog.Info("Fehler: " + AIError.GetLastErrorString());
		return done;
	}
}//end TM
}
//----------------------------------------------------------


/* Is Area Flatable? Returns boolean - under construction - */

function MtestAI::IsFlatable(tile, width, length) {
	local surrounding = 0;
	local tiletoscan = 0;
	surrounding = AITileList();
	surrounding.AddRectangle(tile - AIMap.GetTileIndex(1, 1), tile + AIMap.GetTileIndex(width +1, length +1));
	surrounding.RemoveRectangle(tile, tile + AIMap.GetTileIndex(width, length));
	tiletoscan = surrounding.Next();
	tileheight = TileHeightToBuild(tiletoscan);
}
//-------------------------------------------------------

/* Erase area, returns boolean */
//Todo:	- include invasivity
//		- include demolish roads

function MtestAI::EraseArea(tile, width, length, invasivity) {
	AILog.Info("function EraseArea(" + tile + "; " + width + ", " + length + "; " + invasivity + ")");
	local i = 0;
	local j = 0;
	local demtile = 0;
	local demolished = false;
	local notpossible = false;
	AISign.BuildSign(tile, "Tile to clear");
	for (i=0; i<width; i++) {
		for (j=0; j<length; j++) {
			demtile = tile + AIMap.GetTileIndex(i, j);
			if (AITile.IsBuildable(demtile) == false) {
				demolished = AITile.DemolishTile(demtile);
			} else {
				demolished = false;
//				AILog.Info("  Tile (" + i + ", " + j + ") is free");
			}
			if (demolished == true) {
				AILog.Info("  Tile (" + i + ", " + j + ") cleared");
			} else if (demolished == false && AITile.IsBuildable(demtile) == false) {
				notpossible = true;
				if (AIError.GetLastErrorString() == AIError.ERR_LOCAL_AUTHORITY_REFUSES) {
//					PlantTrees(townid);
//					Bribe(townid);
				}
				AILog.Info("  Tile (" + i + ", " + j + ") could NOT be cleared");
			}
		}
	}
	if (notpossible == true) {
		AILog.Info("  Area could NOT be cleared");
		AILog.Info("Fehler: " + AIError.GetLastErrorString());
		return false;
	} else {
		return true;
		AILog.Info("  Area cleared");
	}
}
//-------------------------------------------------------

/* Looks if area is in same height, returns boolean */
//	NOT IN USE

function MtestAI::TileSameHeight(tile, width, length) {
	AILog.Info("function TileSameHeigth (" + tile + "; " + width + ", " + length + ")");
	local tileheight = 0;
	local tilepos = 0;
	local surface = AIList();
	local ind = 0;
	local i = 0;
	for (i = 0; i < width; i++) {
		local k = 0;
		for (k = 0; k < length; k++) {
			tilepos = tile + AIMap.GetTileIndex(i, k);
			tileheight = AITile.GetHeight(tilepos);
			AILog.Info("  " + i + ", " + k + " Hoehe: " + tileheight);
			surface.AddItem(ind, tileheight);
			ind++;
		}
	}
	surface.KeepValue(tileheight);
	if (surface.Count() == width*length) {
		AILog.Info("  Flaeche ist auf gleicher Hoehe.");
		AISign.BuildSign(tilepos, "Hier Flaeche auf gleicher Hoehe.");
		return true;
	} else {
		AILog.Info("  Flaeche ist uneben.");
		return false;
	}
}
//-------------------------------------------------------------

/* Find nearest place, returns tileindex */
//To do:	- include tilenumber. done
//		- respect roads
//		- respect owner of tile

function MtestAI::FindPlaceNearTile(tile, width, length, ambit, tilenumber, invasivity) {
	AILog.Info("function FindPlaceNearTile(" + tile + "; " + width + ", " + length + "; " + ambit + "; " + tilenumber + "; " + invasivity + ")");
	local i = 0;
	local j = 0;
	local k = 0;
	local tileindex = 0;
	local area = width * length;
	local distance = 0;
	local region = AITileList();
	region.AddRectangle(tile + AIMap.GetTileIndex(ambit, ambit), tile - AIMap.GetTileIndex(ambit +width -1, ambit +length -1));
	local tilepool = AITileList();
	AILog.Info("  region.Count: " + region.Count());
	for (i=0; i <= region.Count(); i++) {
		if (i == 0) {
			tileindex = region.Begin();
		} else {
			tileindex = region.Next();
		}
		local counter = 0;
		for (j=0; j < width; j++) {
			for (k=0; k < width; k++) {
				local currenttile = tileindex + AIMap.GetTileIndex(j, k);
				if (AITile.IsBuildable(currenttile) == false) {
					counter++;
					if (AIRoad.IsRoadTile(currenttile) == true) {
						counter = area + 1;
					}
					if (AITile.GetOwner(currenttile) != AICompany.INVALID_COMPANY) {
						counter = area + 1;
					}
				}
			}
		}
		local maxtilesbuilded = area * invasivity;
//		AILog.Info(i + "  Counter: " + counter + "; maxtilesbuilded: " + maxtilesbuilded);

		if (counter <= area * invasivity) {
			distance = AITile.GetDistanceSquareToTile(tile, tileindex);
//			AILog.Info("  Tileindex: " + tileindex + "; distance: " + distance);
			tilepool.AddTile(tileindex);
			tilepool.SetValue(tileindex, distance);
		} else {
//			region.RemoveTile(tileindex);
		}
	}
	tilepool.Sort(AIAbstractList.SORT_BY_VALUE, true);
	local spot = tilepool.Begin();
	local n = 0;
	for (n=0; n < tilenumber; n++) {
		spot = tilepool.Next()
	}


	AILog.Info("Fehler: " + AIError.GetLastErrorString());
	AILog.Info("  Spot: " + spot + "; Distance: " + tilepool.GetValue(spot));
	return spot;


}
//--------------------------------------------------------------

/* Find free place near given tile, returns tileindex */
/*To do:	- find exactly nearest place*/
/*		- create weighted selection (acceptance)*/
/*		- include water*/
//		- include invasivity
//	NOT IN USE -> FindPlaceNearTile() is much better

function MtestAI::FindFreePlace(tile, width, length, ambit, tilenumber, invasivity) {
	AILog.Info("function FindFreePlace (" + tile + "; " + width + ", " + length + "; " + ambit + "; " + tilenumber + "; " + invasivity + ")");
	local i = 0;
	local isplacefree = false;
	local listcount = 0;
	local tilecount = 0;
	local freetile = 0;
	local area = 0;
	local distance = 0;
	while (isplacefree == false) {
		area = AITileList();
		area.AddRectangle(tile + AIMap.GetTileIndex(i, i), tile - AIMap.GetTileIndex(i +width -1, i +length -1));
		/* For Manhattan distance: */
		/*local k = 0;
		for (k=1; k <= i; k++) {
			area.RemoveRectangle(tile + AIMap.GetTileIndex(i, k), tile + AIMap.GetTileIndex(i-k+1, k));
			area.RemoveRectangle(tile + AIMap.GetTileIndex(i, -k), tile + AIMap.GetTileIndex(i-k+1, -k));
			area.RemoveRectangle(tile + AIMap.GetTileIndex(-i, k), tile + AIMap.GetTileIndex(-i+k-1, k));
			area.RemoveRectangle(tile + AIMap.GetTileIndex(-i, -k), tile + AIMap.GetTileIndex(-i+k-1, -k));
		}*/
		listcount = area.Count();
		/*AILog.Info(i + ". Reihe mit " + listcount + " Teilen in der Liste.");*/

		freetile = area.Begin();
		/* For the nearest place */
	//	distance = (AITile.GetDistanceSquareToTile(tile,freetile));
	//	if (i*i >= distance) {
			isplacefree = AITile.IsBuildableRectangle(freetile, width, length);
	//	}
		/*AILog.Info("Ist erster Platz frei? -" + isplacefree);*/
		if (isplacefree == true) {
			tilecount++;
			/*AILog.Info("Erster Tilecount: " + tilecount + " < " + tilenumber + " ?");*/
			if (tilecount < tilenumber) {
				isplacefree = false;
				/*AILog.Info("isplacefree: " + isplacefree);*/
			}
		}

		local k = 2;
		while (isplacefree == false) {
			if (k > listcount) {
				/*AILog.Info("  " + i + ". Reihe mit " + listcount + " Plaetzen nicht frei.");*/
				break;
			}

			freetile = area.Next();
			/* For the nearest place */
	//		distance = (AITile.GetDistanceSquareToTile(tile,freetile));
	//		if (i*i >= distance) {
				isplacefree = AITile.IsBuildableRectangle(freetile, width, length);

//				invasivity
	//		}
			/*AILog.Info("Ist der Platz von Teil " + k + " frei? -" + isplacefree);*/
			if (isplacefree == true) {
				tilecount++;
				/*AILog.Info("Tilecount: " + tilecount + " < " + tilenumber + " ?");*/
				if (tilecount < tilenumber) {
					isplacefree = false;
					/*AILog.Info("isplacefree: " + isplacefree);*/
				}
			}

			k++;
		}
		if (i >= ambit) {
			AILog.Info("  Kein Platz frei im Umkreis von " + ambit + " Feldern.");
			break;
		}
		i++;
	}
	if (isplacefree == true) {
		i--;
		AILog.Info("  Hier " + tilecount + ". Platz in " + i + ". Reihe gefunden; id: " + freetile);
		/*AISign.BuildSign(freetile, "Hier " + tilecount + ". freie Flaeche mit id: " + freetile);*/
		return freetile;
	} else {
		AILog.Info("  Keinen freien Platz gefunden.");
		return 0;
	}
}
//-----------------------------------------------------------------------

/* Build bus station in town, returns boolean */
/*To do:	- respect acceptance, roads */

function MtestAI::BuildBusStation() {
	AILog.Info("function BuildBusStation ()");
	local townid = BiggestTown(1);
	local townname = AITown.GetName(townid);
	local townpos = AITown.GetLocation(townid);
	local buildable = false;
	local freeplace = 0;
	local busstation = 0;
	local fronttile = 0;
	local i = 0;
	while (buildable == false && i < 40) {
		i++;
		freeplace = FindFreePlace(townpos, 1, 1, 20, i, 0);
		AILog.Info("  " + i + ". planned bus station position: " + freeplace);
		buildable = IsBuildable(freeplace, 1, 1);
		if (buildable == true) {
			fronttile = SearchFrontTile(freeplace);
			if (fronttile == 0) {
				buildable = false;
			}
		}
	}

	busstation = AIRoad.BuildRoadStation(freeplace, fronttile, false, false, true);
	if (busstation == false) {
		AILog.Info("  Konnte Bushalt NICHT in " + townname + " bauen.");
		return false;
	} else {
		AIRoad.BuildRoad(fronttile, freeplace);
		AILog.Info("  Konnte Bushalt in " + townname + " bauen.");
		return true;
	}

}
//-----------------------------------------------------------------------------

/* auxfunction search fronttile for roadstation/depot, returns fronttile index */

function MtestAI::SearchFrontTile(tile) {
	AILog.Info("  auxfunction SearchFrontTile (" + tile + ")");
	local j = 1;
	local adjacenttiles = 0;
	local fronttile = 0;
	local isroad = false;

	if (AIRoad.GetNeighbourRoadCount(tile) > 0) {
		AILog.Info("  NeighbourRoadCount: " + AIRoad.GetNeighbourRoadCount(tile));
		adjacenttiles = AITileList();
		adjacenttiles.AddTile(tile + AIMap.GetTileIndex(1, 0));
		adjacenttiles.AddTile(tile + AIMap.GetTileIndex(0, 1));
		adjacenttiles.AddTile(tile + AIMap.GetTileIndex(-1, 0));
		adjacenttiles.AddTile(tile + AIMap.GetTileIndex(0, -1));
		fronttile = adjacenttiles.Begin();
		isroad = AIRoad.IsRoadTile(fronttile);
		while (isroad == false && j < 5) {
			isroad = AIRoad.IsRoadTile(fronttile);
			fronttile = adjacenttiles.Next();
			j++;
		}
		AILog.Info("  Fronttile: " + fronttile);
		return fronttile;
	} else {
		AILog.Info("  Keine angrenzende Strasse");
		return 0;
	}


}
//-----------------------------------------------------------------------------

/* Build airport in town, returns airport index */
/*To do:	- respect acceptance */

function MtestAI::BuildAirport(townnumber) {
	AILog.Info("function BuildAirport(" + townnumber + ")");
	local townid = BiggestTown(townnumber);
	local townname = AITown.GetName(townid);
	local townpos = AITown.GetLocation(townid);
	local porttype = 255;
	if (AIAirport.AirportAvailable(AIAirport.AT_LARGE) == true) {
		porttype = AIAirport.AT_LARGE;
	} else if (AIAirport.AirportAvailable(AIAirport.AT_SMALL) == true){
		porttype = AIAirport.AT_SMALL;
	} else {
		porttype = AIAirport.AT_COMMUTER;
	}
	local portwidth = AIAirport.GetAirportWidth(porttype);
	local portlength = AIAirport.GetAirportHeight(porttype);
	AILog.Info("  Flughafen-Flaeche: (" + portwidth + ", " + portlength + ")");

	
	local maxloan = AICompany.GetMaxLoanAmount();
	AICompany.SetLoanAmount(maxloan);
//	BorrowMoney(maxloan);

	local i = 0;
	local done = false;
	local freeplace = 0;
	local airport = false;
	while (airport == false) {
		i++;
		freeplace = FindPlaceNearTile(townpos, portwidth, portlength, 8, i, 0.1);
		AISign.BuildSign(freeplace, "Hier " + i + ". freie Flaeche");

	{	//transactionmode begin
		local posscout = AITransactionMode();
		local erase = EraseArea(freeplace, portwidth, portlength, 0.1);
		AILog.Info("erase = " + erase);
		local level = 0;
		local flatten = false;
		while (flatten == false && level <= 4) {
			flatten = FlattenArea(freeplace, portwidth + 1, portlength + 1, level);
			AILog.Info("flatten = " + flatten + "; level: " + level);
			if (flatten == true) {
				level = 5;
			}
			level++;
		}
		AILog.Info("flatten = " + flatten + "; erase: " + erase);
		if (erase == true && flatten == true) {
			local buildcosts = posscout.GetCosts();
			AILog.Info("Costs = " + buildcosts);
			done = posscout.Execute();
			AILog.Info("Fehler: " + AIError.GetLastErrorString());
		} else {
			posscout.Stop();
		}
		AILog.Info("done = " + done);
	}	//tm end
		if (done == true) {
	{	//tm begin
			local portscout = AITransactionMode();
			airport = AIAirport.BuildAirport(freeplace, porttype, true);
			AILog.Info("Fehler: " + AIError.GetLastErrorString());
			AILog.Info(i + ". airport = " + airport);
			if (airport == true) {
				local buildcosts = portscout.GetCosts();
				AILog.Info("Costs = " + buildcosts);
//				BorrowMoney(buildcosts);
				done = portscout.Execute();
			} else {
				portscout.Stop();
			}
	}	//tm end
		}
	}
	local buildable = IsBuildable(freeplace, portwidth, portlength);

	if (airport == false) {
		AILog.Info("  Konnte Flughafen NICHT in " + townname + " bauen.");
		return false;
	} else {
		AILog.Info("  Konnte Flughafen in " + townname + " bauen.");
		return freeplace;
	}

}
//------------------------------------------------------------------------------

/* Random number */

function MtestAI::Random(limes) {
	local randnr = 0;
	randnr = AIBase.RandRange(limes);
	return randnr;
}
//------------------------------------------------------------------------------

/* Testfunction */

function MtestAI::TestFunction() {
	AILog.Info("> > function TestFunction()");
	local townpos = AITown.GetLocation(BiggestTown(1));
	local pos = townpos + AIMap.GetTileIndex(10, -30);

	local buildcosts = 0;
	local isdone = false;

	local maxloan = AICompany.GetMaxLoanAmount();
	AICompany.SetLoanAmount(maxloan);

	AISign.BuildSign(pos, "Hello");
	AISign.BuildSign(pos + 1, "Hello1");

/*	{
	local scout = AITransactionMode();
	local cleared = EraseArea(pos, 3, 3, 0.5);
	buildcosts = scout.GetCosts();
	AILog.Info("Kosten: " + buildcosts);
	if (buildcosts > 1700 || cleared == false) {
		scout.Stop();
		AILog.Info("Zu teuer oder nicht ausfuehrbar.");
	} else {
		isdone = scout.Execute();
		if (isdone == false) {
			AILog.Info("Nicht ausgefuehrt.");
		} else {
			AILog.Info("TransactionMode ausgefuehrt.");
		}
	}
	}*/

	{	//transactionmode begin
		local posscout = AITransactionMode();
		FlattenArea(pos, 7, 7, 0);
		FlattenArea(pos + AIMap.GetTileIndex(1, 1), 5, 5, 1);
		local done = posscout.Execute();
	}

//	scout.Rollback();

//	BuildBusStation();
	AISign.BuildSign(pos + 3, "Hier3");

}
//------------------------------------------------------------------------------

/* Build two Airports and one Plane */

function MtestAI::BuildAirBridge() {
	local buildcosts = 0;
	local isdone = false;
	local scout = 0;

	local airportone = BuildAirport(1);
	local airporttwo = BuildAirport(2);

	AILog.Info("Kosten: " + buildcosts);
 	if (airportone == false || airporttwo == false) {
		AILog.Info("Zu wenig Flughaefen!");
	} else {
		local hangartile = AIAirport.GetHangarOfAirport(airportone);
		local planeid = BuildAirplane(hangartile, AIAirport.PT_BIG_PLANE);

		/* orders */
		AIOrder.InsertOrder(planeid, AIOrder.CURRENT_ORDER, airportone, AIOrder.AIOF_NONE);
		AIOrder.InsertOrder(planeid, AIOrder.CURRENT_ORDER, airporttwo, AIOrder.AIOF_NONE);
		AIVehicle.StartStopVehicle(planeid);
	}

}
//-------------------------------------------------------------------------------

/* Build Airplane, returns planeid */

function MtestAI::BuildAirplane(hangartile, planetype) {
	AILog.Info("function BuildAirplane(" + hangartile + ", " + planetype + ")");
	local i = 0;
	local engine = 0;
	local planeid = 0;
	local porttype = 255;
	local planesize = -1;	/* entfernen */
	local available = false;
	local allplanes = AIEngineList(AIVehicle.VEHICLE_AIR);
//	don't need planetype in header...
	local porttype = AIAirport.GetAirportType(hangartile);
	if (porttype == 0 || porttype == 5) {
		planetype = AIAirport.PT_SMALL_PLANE;
	} else if (porttype == 2 || porttype == 6 || porttype == 8) {
		planetype = AIAirport.PT_HELICOPTER;
	} else /*1,3,4,7*/{
		planetype = AIAirport.PT_BIG_PLANE;
	}
	allplanes.Valuate(AIEngine.GetReliability);
	allplanes.Sort(AIAbstractList.SORT_BY_VALUE, false);
	engine = allplanes.Begin();
	available = AIEngine.IsValidEngine(engine);
	planesize = AIEngine.GetPlaneType(engine);
	local speed = AIEngine.GetMaxSpeed(engine);
	AILog.Info("  Beg. Engine " + engine + " existiert: " + available + ";  Groesse: " + planesize + ";  Speed: " + speed);
	/* Filter Yate Haugan out */
	if (AICompany.GetLoanAmount() > 0 && speed > 238) {
		AILog.Info("  Beg. Sorry, Yate Haugan ist zu teuer.");
		available = false;
	}
	while (available == false || planetype != planesize) {
		engine = allplanes.Next();
		available = AIEngine.IsValidEngine(engine) 
		planesize = AIEngine.GetPlaneType(engine);
		speed = AIEngine.GetMaxSpeed(engine);
		AILog.Info("  Engine " + engine + " existiert: " + available + ";  Groesse: " + planesize + ";  Speed: " + speed);
		/* Filter Yate Haugan out */
		if (AICompany.GetLoanAmount() > 0 && speed == 583) {
			AILog.Info("  Sorry, Yate Haugan ist zu teuer.");
			available = false;
		}
	}
	local price = AIEngine.GetPrice(engine);
	AILog.Info("  Flugzeugkosten: " + price);
	BorrowMoney(price);
	planeid = AIVehicle.BuildVehicle(hangartile, engine);

	if (AIVehicle.IsValidVehicle(planeid) == true) {
		AILog.Info("  Flugzeug gebaut. " + planeid);
		return planeid;
	} else {
		AILog.Info("  Flugzeug ist NICHT gebaut!" + planeid);
		return 0;
	}
}
//--------------------------------------------------------------

/* Manages airports */

function MtestAI::ManageAirports() {
	local i = 0;
	local portid = 0;
	local porttype = 255;
	local portname = 0;
	local passengers = 0;
	local portpos = 0;
	local hangartile = 0;
	local portupgrade = 255;
	local portwidth = 0;
	local allairports = AIStationList(AIStation.STATION_AIRPORT);
	local maxplanes = 0;

	portid = allairports.Begin();
//	Cycle through all airports
	for (i=0; i < allairports.Count(); i++) {
		portpos = AIStation.GetLocation(portid);
		porttype = AIAirport.GetAirportType(portpos);
		hangartile = AIAirport.GetHangarOfAirport(portpos);
		switch (porttype) {
			case AIAirport.AT_SMALL:
				maxplanes = 5;
				if (AIAirport.AirportAvailable(AIAirport.AT_LARGE) == true) {
					portupgrade = AIAirport.AT_LARGE;
				} else if (AIAirport.AirportAvailable(AIAirport.AT_COMMUTER) == true) {
					portupgrade = AIAirport.AT_COMMUTER;
				}
				break;
			case AIAirport.AT_LARGE:
				maxplanes = 10;
				if (AIAirport.AirportAvailable(AIAirport.AT_METROPOLITAN) == true) {
					portupgrade = AIAirport.AT_METROPOLITAN;
				}
				break;
			case AIAirport.AT_METROPOLITAN:
				maxplanes = 15;
				if (AIAirport.AirportAvailable(AIAirport.AT_INTERNATIONAL) == true) {
					portupgrade = AIAirport.AT_INTERNATIONAL;
				}
				break;
			case AIAirport.AT_INTERNATIONAL:
				maxplanes = 20;
				if (AIAirport.AirportAvailable(AIAirport.AT_INTERCON) == true) {
					portupgrade = AIAirport.AT_INTERCON;
				}
				break;
			case AIAirport.AT_INTERCON:
				maxplanes = 30;
				break;
			case AIAirport.AT_COMMUTER:
				maxplanes = 12;
				break;
			case AIAirport.AT_HELIPORT:
				break;
			case AIAirport.AT_HELIDEPOT:
				break;
			case AIAirport.AT_HELISTATION:
				break;
			case AIAirport.AT_INVALID:
				maxplanes = -1;
				break;
		}
		AILog.Info("porttype: " + porttype + "; portupgrade: " + portupgrade);
//		Fix it...
		if (portupgrade != 255) {
			local price = AIEngine.GetPrice(232);
			AILog.Info("  Flugplatzkosten: " + price);
			BorrowMoney(price);
			local remove = AIAirport.RemoveAirport(hangartile);
			if (remove == true) {
				AILog.Info("Airport removed");
				AIAirport.BuildAirport(portpos, portupgrade, true);
//				AILog.Info("Fehler: " + AIError.GetLastErrorString());
			} else {
				AILog.Info("Airport NOT removed");
			}
		}
		local planestoport = AIVehicleList_Station(portid);
		AILog.Info("Planes to this airport: " + planestoport.Count() + " of max " + maxplanes);

		portname = AIStation.GetName(portid);
		passengers = AIStation.GetCargoWaiting(portid, 0);
		AILog.Info("  In " + portname + " waiting people: " + passengers);
		if (passengers > 1000 && planestoport.Count() < maxplanes) {
			portpos = AIStation.GetLocation(portid);
			hangartile = AIAirport.GetHangarOfAirport(portpos);
			local planeid = BuildAirplane(hangartile, AIAirport.PT_BIG_PLANE);

			/* orders */
			AIOrder.InsertOrder(planeid, AIOrder.CURRENT_ORDER, portpos, AIOrder.AIOF_NONE);
			local porttwo = 0;
			if (allairports.HasNext() == true) {
				porttwo = allairports.Next();
				AILog.Info("H" + porttwo);
			} else {
				porttwo = allairports.Begin();
				AILog.Info("Beg." + porttwo);
			}
			if (porttwo == portid) {
				if (allairports.HasNext() == true) {
					porttwo = allairports.Next();
					AILog.Info("H" + porttwo);
				} else {
					porttwo = allairports.Begin();
					AILog.Info("Beg." + porttwo);
				}
			}

			AIOrder.InsertOrder(planeid, AIOrder.CURRENT_ORDER, AIStation.GetLocation(porttwo), AIOrder.AIOF_NONE);
			AIVehicle.StartStopVehicle(planeid);
		} else {
			portid = allairports.Next();
		}
	}

//		AIAirport.GetAirportType();
//		AIAirport.GetNumHangars();
//		AIEngine.GetPlaneType();	PT_SMALL_PLANE = 1;	PT_BIG_PLANE = 3;	PT_HELICOPTER = 0;	PT_INVALID = -1
//AIAirportAvailable(1);

}
//------------------------------------------------------------------

/* Manage Airplanes */

function MtestAI::ManageAirplanes() {
	AILog.Info("function ManageAirplanes()");
	local port = -1;
	local allairports = AIStationList(AIStation.STATION_AIRPORT);
	local vehiclelist = AIVehicleList();
	port = allairports.Begin();
	vehiclelist.AddList(AIVehicleList_Station(port));
//	Cycle through all airports
	local j = 0;
	for (j=0; j < allairports.Count(); j++) {
		vehiclelist.AddList(AIVehicleList_Station(port));
	}
	local vehicleid = 0;
	local i = 0;
	for (i=0; i < vehiclelist.Count(); i++) {
		vehicleid = vehiclelist.Next();
		if (AIVehicle.GetAgeLeft(vehicleid) < 21) {
			AIVehicle.SendVehicleToDepot(vehicleid);
		}
	}
}
//--------------------------------------------------------------------





